Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# GT2005LineCrossingsTable Class Reference

`#include <GT2005LineCrossingsTable.h>`

Collaboration diagram for GT2005LineCrossingsTable:

[legend]
List of all members.

## Public Types
enum | CrossingClass { virtualCrossing, lCrossing, tCrossing, xCrossing, outerLCrossing, outerTCrossing, outerVirtualCrossing, falseCrossing, numOfCrossingClasses }
## Public Member Functions
| GT2005LineCrossingsTable ()
Vector2< double > | getClosestPoint (const Vector2< double > &point, CrossingClass crossingClass, int orientation) const
Vector2< double > | getClosestPoint (const Pose2D &pose, const LinesPercept::LineCrossingPoint &crossingPoint, CrossingClass &crossingClass) const
## Static Public Attributes
int | NO_POINT_DISTANCE = 100000
## Private Types
enum | { maxNumOfCrossings = 6 }
## Private Member Functions
void | addCrossing (CrossingClass crossingClass, int orientation, double x, double y)
void | initVirtualCrossings ()
void | initTCrossings ()
void | initLCrossings ()
void | initXCrossings ()
void | initFalseCrossings ()
void | updateClosestPoint (Vector2< double > &minimum, double &minDist, const Vector2< double > &pose, CrossingClass crossingClass, int orientation, CrossingClass &minCrossingClass) const
## Private Attributes
int | numOfCrossings [numOfCrossingClasses][4]
Vector2< double > | crossings [numOfCrossingClasses][4][maxNumOfCrossings]

## Member Enumeration Documentation

enum GT2005LineCrossingsTable::CrossingClass

  | Enumeration values:
  virtualCrossing |
  lCrossing |
  tCrossing |
  xCrossing |
  outerLCrossing |
  outerTCrossing |
  outerVirtualCrossing |
  falseCrossing |
  numOfCrossingClasses |
Definition at line 23 of file GT2005LineCrossingsTable.h.

anonymous enum`[private]`

  | Enumeration values:
  maxNumOfCrossings |
Definition at line 43 of file GT2005LineCrossingsTable.h.

## Constructor & Destructor Documentation

GT2005LineCrossingsTable::GT2005LineCrossingsTable | ( |  | ) |

| Definition at line 14 of file GT2005LineCrossingsTable.cpp. References initFalseCrossings(), initLCrossings(), initTCrossings(), initVirtualCrossings(), initXCrossings(), numOfCrossingClasses, and numOfCrossings.

Here is the call graph for this function:

## Member Function Documentation

Vector2< double > GT2005LineCrossingsTable::getClosestPoint | ( | const Vector2< double > & | point,
|  | CrossingClass | crossingClass,
|  | int | orientation
| ) | const

| Definition at line 96 of file GT2005LineCrossingsTable.cpp. References NO_POINT_DISTANCE, point, and updateClosestPoint(). Referenced by GT2005SelfLocator::updateByCrossing().

Here is the call graph for this function:

Vector2< double > GT2005LineCrossingsTable::getClosestPoint | ( | const Pose2D & | pose,
|  | const LinesPercept::LineCrossingPoint & | crossingPoint,
|  | CrossingClass & | crossingClass
| ) | const

| Definition at line 119 of file GT2005LineCrossingsTable.cpp. References lCrossing, NO_POINT_DISTANCE, normalize(), outerLCrossing, outerTCrossing, outerVirtualCrossing, LinesPercept::LineCrossingPoint::outOfImage, pi2, pi_2, pi_4, Pose2D::rotation, LinesPercept::LineCrossingPoint::side1, LinesPercept::LineCrossingPoint::side2, LinesPercept::LineCrossingPoint::side3, LinesPercept::LineCrossingPoint::side4, tCrossing, Pose2D::translation, updateClosestPoint(), virtualCrossing, and xCrossing.

Here is the call graph for this function:

void GT2005LineCrossingsTable::addCrossing | ( | CrossingClass | crossingClass,
|  | int | orientation,
|  | double | x,
|  | double | y
| ) | `[inline, private]`

| Definition at line 51 of file GT2005LineCrossingsTable.h. References crossings, numOfCrossings, Vector2< double >::x, and Vector2< double >::y. Referenced by initFalseCrossings(), initLCrossings(), initTCrossings(), initVirtualCrossings(), and initXCrossings().

void GT2005LineCrossingsTable::initVirtualCrossings | ( |  | ) | `[private]`

| Definition at line 26 of file GT2005LineCrossingsTable.cpp. References addCrossing(), outerVirtualCrossing, and virtualCrossing. Referenced by GT2005LineCrossingsTable().

Here is the call graph for this function:

void GT2005LineCrossingsTable::initTCrossings | ( |  | ) | `[private]`

| Definition at line 54 of file GT2005LineCrossingsTable.cpp. References addCrossing(), and outerTCrossing. Referenced by GT2005LineCrossingsTable().

Here is the call graph for this function:

void GT2005LineCrossingsTable::initLCrossings | ( |  | ) | `[private]`

| Definition at line 66 of file GT2005LineCrossingsTable.cpp. References addCrossing(), lCrossing, and outerLCrossing. Referenced by GT2005LineCrossingsTable().

Here is the call graph for this function:

void GT2005LineCrossingsTable::initXCrossings | ( |  | ) | `[private]`

| Definition at line 90 of file GT2005LineCrossingsTable.cpp. References addCrossing(), and xCrossing. Referenced by GT2005LineCrossingsTable().

Here is the call graph for this function:

void GT2005LineCrossingsTable::initFalseCrossings | ( |  | ) | `[private]`

| Definition at line 84 of file GT2005LineCrossingsTable.cpp. References addCrossing(), and falseCrossing. Referenced by GT2005LineCrossingsTable().

Here is the call graph for this function:

void GT2005LineCrossingsTable::updateClosestPoint | ( | Vector2< double > & | minimum,
|  | double & | minDist,
|  | const Vector2< double > & | pose,
|  | CrossingClass | crossingClass,
|  | int | orientation,
|  | CrossingClass & | minCrossingClass
| ) | const`[private]`

| Definition at line 105 of file GT2005LineCrossingsTable.cpp. References Vector2< V >::abs(), crossings, numOfCrossings, and point. Referenced by getClosestPoint().

Here is the call graph for this function:

## Member Data Documentation

int GT2005LineCrossingsTable::NO_POINT_DISTANCE = 100000`[static]`

| Definition at line 12 of file GT2005LineCrossingsTable.cpp. Referenced by getClosestPoint().

int GT2005LineCrossingsTable::numOfCrossings[numOfCrossingClasses][4]`[private]`

| Definition at line 47 of file GT2005LineCrossingsTable.h. Referenced by addCrossing(), GT2005LineCrossingsTable(), and updateClosestPoint().

Vector2<double> GT2005LineCrossingsTable::crossings[numOfCrossingClasses][4][maxNumOfCrossings]`[private]`

| Definition at line 48 of file GT2005LineCrossingsTable.h. Referenced by addCrossing(), and updateClosestPoint().

The documentation for this class was generated from the following files:

- Modules/SelfLocator/GT2005SelfLocator/GT2005LineCrossingsTable.h
- Modules/SelfLocator/GT2005SelfLocator/GT2005LineCrossingsTable.cpp